
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module VGA(

	//////////// CLOCK //////////
	CLOCK_50,

	//////////// LED //////////
	LED,

	//////////// KEY //////////
	KEY,

	//////////// SW //////////
	SW,

	//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
	GPIO,
	GPIO_IN 
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		CLOCK_50;

//////////// LED //////////
output		     [7:0]		LED;

//////////// KEY //////////
input 		     [1:0]		KEY;

//////////// SW //////////
input 		     [3:0]		SW;

//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
inout 		    [33:0]		GPIO;
input 		     [1:0]		GPIO_IN;


//=======================================================
//  REG/WIRE declarations
//=======================================================

wire [10:0]CounterX;
wire [10:0]CounterY;

reg[3:0]lcd_r_out;
reg[3:0]lcd_g_out;
reg[3:0]lcd_b_out;
wire video_on;
wire V_SYNC;
wire H_SYNC;

reg[10:0]pos_x=11'd320;
reg[10:0]pos_y=11'd370;
reg pos_x_flag=1'b0;
reg pos_y_flag=1'b0;
wire frame=(CounterX == 11'd639) && (CounterY ==11'd479);

assign GPIO[0]=lcd_r_out[3];
assign GPIO[1]=lcd_r_out[2];
assign GPIO[3]=lcd_r_out[1];
assign GPIO[5]=lcd_r_out[0];
assign GPIO[7]=lcd_g_out[3];
assign GPIO[9]=lcd_g_out[2];
assign GPIO[11]=lcd_g_out[1];
assign GPIO[13]=lcd_g_out[0];
assign GPIO[15]=lcd_b_out[3];
assign GPIO[17]=lcd_b_out[2];
assign GPIO[19]=lcd_b_out[1];
assign GPIO[21]=lcd_b_out[0];
assign GPIO[23]=V_SYNC;
assign GPIO[25]=H_SYNC;

localparam IMAGE_W=11'd269;
localparam IMAGE_W2=11'd45;
localparam IMAGE_H=11'd56;

wire [10:0]offset=(source_frame[5:3]==3'd0)?0:
						(source_frame[5:3]==3'd1)?IMAGE_W2*1:
						(source_frame[5:3]==3'd2)?IMAGE_W2*2:
						(source_frame[5:3]==3'd3)?IMAGE_W2*3:
						(source_frame[5:3]==3'd4)?IMAGE_W2*4:
						IMAGE_W2*5;
						
wire [3:0]alpha=SW[3:0];
wire [11:0]red_blended=(((rgb_image[11:8])*alpha)+(4'hF *(4'hF-alpha)))/4'hF;
wire [11:0]green_blended=(((rgb_image[7:4])*alpha)+(4'h0 *(4'hF-alpha)))/4'hF;
wire [11:0]blue_blended=(((rgb_image[3:0])*alpha)+(4'h0 *(4'hF-alpha)))/4'hF;
//=======================================================
//  Structural coding
//=======================================================

wire [13:0]address_image = (CounterY-pos_y)*IMAGE_W+(CounterX+offset-pos_x[10:0]);
wire [11:0]rgb_image;

imagen	imagen_inst
(
	.address (address_image),
	.clock (~clk_25mhz),
	.q (rgb_image)
);

wire clk_25mhz;
pll_25mhz	pll_25mhz_inst
(
	.inclk0 (CLOCK_50),
	.c0 (clk_25mhz)
);

mi_vga mi_vga_inst
(
	.clk(clk_25mhz) ,	// input  clk_sig
	.h_sync(H_SYNC) ,	// output  h_sync_sig
	.v_sync(V_SYNC) ,	// output  v_sync_sig
	.video_on(video_on) ,	// output  video_on_sig
	.x_pixel(CounterX) ,	// output [N-1:0] x_pixel_sig
	.y_pixel(CounterY) 	// output [N-1:0] y_pixel_sig
);

wire box_on=(CounterX>(1'd0))&&(CounterX<(11'd640))&&(CounterY>(11'd420))&&(CounterY<(11'd480));
wire box1=(CounterX>(11'd80))&&(CounterX<(11'd200))&&(CounterY>(11'd40))&&(CounterY<(11'd100));
wire box2=(CounterX>(11'd440))&&(CounterX<(11'd560))&&(CounterY>(11'd40))&&(CounterY<(11'd100));
wire image_on=(CounterX[10:0]>pos_x)&(CounterX[10:0]<=(pos_x+IMAGE_W2-1))&(CounterY[10:0]>pos_y)&(CounterY[10:0]<=(pos_y+IMAGE_H-1));

always @(negedge clk_25mhz)
begin
	if(!video_on)
	begin 
		lcd_r_out<=4'd0;
		lcd_g_out<=4'd0;
		lcd_b_out<=4'd0;
	end
	else
	begin
		lcd_r_out<=4'h4;
		lcd_g_out<=4'hd;
		lcd_b_out<=4'hc;
		if(box_on)
		begin
			lcd_r_out<=4'd0;
			lcd_g_out<=4'h8;
			lcd_b_out<=4'd0;	
		end
		else if(box1)
		begin
			lcd_r_out<=4'hF;
			lcd_g_out<=4'hF;
			lcd_b_out<=4'hF;	
		end
		else if(box2)
		begin
			lcd_r_out<=4'hF;
			lcd_g_out<=4'hF;
			lcd_b_out<=4'hF;
		end
		else if(image_on==1'b1 && rgb_image!=12'hFFF)
		begin
			lcd_r_out<=rgb_image[11:8];
			lcd_g_out<=rgb_image[7:4];
			lcd_b_out<=rgb_image[3:0];
		end
	end
end

//always@(posedge frame)
//begin
//	pos_x_flag<=pos_x_flag;
//	if(pos_x>=11'd640-11'd50) pos_x_flag<=1'b1;
//	else if (pos_x<=11'd1) pos_x_flag<=1'b0;
//end

//always@(posedge frame)
//begin
//	pos_y_flag<=pos_y_flag;
//	if(pos_y>=11'd480-11'd50) pos_y_flag<=1'b1;
//	else if (pos_y<=11'd1) pos_y_flag<=1'b0;
//end

always@(posedge frame)
begin
	if(KEY[0]==1'b0 && KEY[1]==1'b0)
	begin
		pos_y<=pos_y-1;
	end
	else if(KEY[0]==1'b1 && KEY[1]==1'b1)
	begin
		if(pos_y>=11'd370)
		begin
			pos_y<=11'd370;
		end
		else
		begin
			pos_y<=pos_y+2;
		end
	end
	else if(KEY[1]==1'b0) pos_x<=pos_x-1'b1;
	else if(KEY[0]==1'b0) pos_x<=pos_x+1'b1;
end

//always@(posedge frame)
//begin
//	if(pos_y_flag) pos_y<=pos_y-1'b1;
//	else pos_y<=pos_y+1'b1;
//end

reg [5:0]source_frame;
always@(posedge frame)
begin
	if(source_frame[5:3]==3'd5) source_frame<=6'd0;
	else source_frame<=source_frame+1'b1;
end

endmodule
